/** Adapted from the brent, ralitza, johns? ox function, fNodes, returns **
 ** the Gauss/Hermite weights and nodes in a dataset 					 **/
title;
%macro ghq_wtsnodes(num_nodes,dataname=wtsnodes,gnotes=T);
   options nonotes;
   %if &gnotes=T %then %do;
      %put ; 
	  %put %str(   ) Calculating Gauss/Hermite Weights and Nodes for &num_nodes nodes;
   %end;
   **-- Nodes & weights for Gauss-Hermite Quadrature --**;
   proc iml;
     mat = J(1,&num_nodes,0) // 
  		   ( diag( sqrt( (1:(&num_nodes - 1))/2 ) ) || J(&num_nodes-1,1,0) ) ;
     mat = mat + t(mat);
	 call eigen(eigvals,eigvecs,mat);
     nodes   = sqrt(2) * eigvals;
     weights = (eigvecs[1,]) ## 2;

	 *- Create nodes & weights dataset -*;
	 create &dataname var {nodes weights};
	 append;
  quit;
  proc sort data=&dataname; by nodes; run;
  options notes;
   %if &gnotes=T %then %do;
	  %put %str(   ) Done!;
      %put ; 
   %end;
%mend;
title;
*%ghq_wtsnodes(5,dataname=test);
*proc print data=test; run;

/** Example: f(x) = x^2 **;
%ghq_wtsnodes(5,dataname=test);
proc iml; 
  use test;
  read all var 'nodes' into nodes;
  read all var 'weights' into wts;
  mu=0; sigma=2;
  nd  = mu + sigma * nodes;
  int = sum(wts # nd##2);
  print "Integral of X^2 with E(X)=" mu "sd(X)=" sigma "is the Variance =" int;
quit;
*/
